
#ifndef __BACKEND_H__
#define __BACKEND_H__

#include "../include/common.h"
#include "..\iscsi_lib\AddressHash.h"


typedef struct _MEM_FILE_MAP_T
{
	HANDLE hFile;
	PBYTE pbFile;
	HANDLE hFileMapping;
}MEM_FILE_MAP_T;

#define MAX_MEM_FILE_SIZE		1*1024*1024
#define MEM_FILE_START			0//FILE_HEADER_LEN
#define MEM_FILE_END			(MAX_MEM_FILE_SIZE/BLOCKSIZE-1)
#define MAX_CLIENT_DATA_SIZE 	32*1024*1024

int BE_Init(char* DevName);
int BE_Close(int DevId);

//#ifdef OLD_BACKEND
int BE_Read(int DevId,char* Buff,unsigned long  Lba,unsigned long Length);
int BE_Write(int DevId,char* Buff,unsigned long  Lba,unsigned long Length);
int BE_Read_Byte(int DevId,char* Buff,__int64  Offset,unsigned long Length);
int BE_Write_Byte(int DevId,char* Buff,__int64  Offset,unsigned long Length);

int BE_Init_Private(char* DevName);
int BE_Close_Private(int DevId);
int BE_Clear_Private(int DevId);
int BE_Get_File_Length(int DevId);


/*#else
int BE_Read(int PublicDevId,int PrivateDevId,char* Buff,
			unsigned long  Lba,unsigned long Length);
int BE_Write(int PublicDevId,int PrivateDevId,char* Buff,
			 unsigned long  Lba,unsigned long Length);

#endif*/

#endif//__BACKEND_H__
