#pragma once
#include "common/types.h"

//#define SNAPSHOT_REDIRECT

#ifdef SNAPSHOT_REDIRECT
#define SNAPSHOT_INDEX_FILE_NAME	"SNAPSHOT1.idx"
//#define SNAPSHOT_DATA_FILE_NAME	"SNAPSHOT1.dat"
#define SNAPSHOT_DATA_FILE_NAME	"\\\\.\\k:"
#else
#define SNAPSHOT_INDEX_FILE_NAME	"SNAPSHOT2.idx"
//#define SNAPSHOT_DATA_FILE_NAME	"SNAPSHOT2.dat"
#define SNAPSHOT_DATA_FILE_NAME	"\\\\.\\k:"
#endif

int Snapshot_Init(int dev);
int Snapshot_Close();
int Redirect_Write(char *buf, unsigned long lba, unsigned long length);
int Merge_Read(char *buf, unsigned long lba, unsigned long length);
int Merge_Snapshot(long t_snapshot);
int New_Snapshot(long t_snapshot);
int Copy_on_Write(char *buf, unsigned long lba, unsigned long length);
int Snapshot_Read(char *buf, unsigned long lba, unsigned long length);
